<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
    <link rel="stylesheet" href="style.css">
</head>
<body>
    <main>
        <div>
            <div>
                <h1>Using constraints & “magic numbers” to build
                    responsive layouts in Figma <!--h1, main h1, body main div h1--></h1> 
            <div class="img">
                <img src="https://miro.medium.com/max/1100/1*Y2dJzfk5qWf-vI1MYiiTVw.png" alt=""> 
                <!--.img, main div .img, body main div .img-->
            </div>
        </div>
    </main>
    <section>
        <div class="text"> <!--div > p, div p-->
            <p><i>This post is part of a series:</i>
                <a href="https://medium.com/@littlebits.product/building-a-design-system-with-figma-at-littlebits-17edff8f4236"> 
                    <i> Building a design system with Figma at littleBits </i> <!--a, section div p a, div p a, a:hover-->
                </a><i>Read</i><br>
                <i>the previous post — how we created atomic components with Figma —</i>
                <a href="https://www.figma.com/blog/creating-responsive-layout-templates-in-figma/">
                    <i>here</i> <!--a, section div p a, div p a, a:hover-->
                </a>.
            </p> <!--.text, p:first-child, p:first-of-tyre-->
            <p>This year we faced a big challenge at Little Bits — launching 4 new apps on <br>
                multiple platforms with both mobile and tablet layouts. We knew we needed a <br>
                strong design system to do it right, particularly given our small team and <br>
                time span (6 months). <!--.text, p:nth-child(2)-->
            </p>
            <p>Templates with responsive layouts played a key role in scaling our work. <br>
                Here’s how we figured out the approach that worked for us in both Figma and <br>
                React.
            </p><!--.text, p:last-child, p:last-of-tyre-->
        </div>
    </section>
    <section>
        <div class="text"> <!--div > p, div p -->
            <h2>Magic Number</h2>
            <p>One thing that’s great to have at the heart of a design system is a ‘magic <br>
                number’ — it helps harmonize layout if sizes of text, graphic elements, <br>
                margins, and padding, share a common numeric factor.
            </p> <!--.text, p:first-child, p:first-of-tyre-->
            <p>Before we had any kind of system, we had mocks of several key screens that <br>
                had been created to establish the visual direction of the app.
            </p><!--.text,  p:nth-child(2) -->
            <div class="img">
                <img src="https://miro.medium.com/max/1400/1*TqFz6lS9kuTmok-clI-X1Q.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>We looked at the sizes and padding that had been ‘eyeballed’ in these designs,<br>
                and found that things were mostly working off 8’s — buttons were 48px high,<br>
                margins were mostly 24px, some headings were 32px, etc.
            </p><!--.text,  p:nth-child(3) -->
            <p>Everything was close enough to nudge towards numbers that multiplied from<br>
                8 (and 8 in itself is a number that multiplies and divides well!). So 8 became<br>
                our magic number for all things moving forward.
            </p><!--.text,  p:nth-child(4) -->
            <div class="img">
                <img src="https://miro.medium.com/max/828/1*kmKS2fqTI7jtkDDdwm_VjQ.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>From smallest to largest our buttons and form elements were made 32, 48, 56,<br>
                64, & 96px high; key headings & copy 48, 32, 24, & 16px; padding & gutters 16,<br>
                24, & 32px; larger layout cards would be 240px high.<br>
            </p><!--.text,  p:nth-child(5) -->
            <p>You get the picture…all the key sizes are multiples of 8!</p>
            <!--.text, p:last-child, p:last-of-tyre-->
        </div>
    </section>
    <section>
        <div class="text"> <!--div > p, div p -->
            <h2>Different Screen Sizes</h2>
            <p>Figma is great for building with responsive constraints — you can stretch your<br>
                layouts and see how they will respond to changes in screen size. (If you’re new<br>
                to constraints in Figma, check out this beginner primer here.)<br>
            </p> <!--.text, p:first-child, p:first-of-tyre-->
            <p>You can even have elements pin to edges of a column:</p><!--.text,  -->
            <div class="img">
                <img src="https://miro.medium.com/max/750/1*dFGDlSVyHIKEtHyrcMGxHA.gif" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>But it’s hard to create a single layout that will look good on most phones, still<br>
                fit on a smaller phone like an iPhone SE, and feel full on a tablet.<br>
            </p><!--.text,  p:nth-child(2) -->
            <div class="img">
                <img src="https://miro.medium.com/max/828/1*-tgO36tfC_joP2YCHuKZhA.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>Around half our users are loading the app on a tablet, so we didn’t want the<br>
                experience there to feel like an afterthought. We didn’t want our designs to be<br>
                compromised to fit with smaller screens either.
            </p><!--.text,  p:nth-child(3) -->
            <p>In this case our designs were sympathetic to being proportionally scaled up<br>
                and down, so we looked at the relationship between different screen sizes to<br>
                get scaling ratios:
            </p><!--.text,  p:nth-child(4) -->
            <div class="img">
                <img src="https://miro.medium.com/max/750/1*GzOYNQg-YmBExV_6o_kihg.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>Then we rounded out the ratio values so we could keep whole numbers as we<br>
                scaled:
            </p><!--.text,  p:nth-child(5) -->
            <div class="img">
                <img src="https://miro.medium.com/max/828/1*UnBgpVjRk01Gbapzh9Vxng.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>We baked these rules into how the React codebase calculated sizes (along with<br>
                typical layout constraints).
            </p><!--.text,  p:nth-child(6) -->
            <p>Because our templates were designed with this system in mind, when we <br>
                tested the final build on tablets and smaller phones, things looked great right <br>
                out of the box without needing extra adjustments.
            </p><!--.text,  p:nth-child(7) -->
            <p>In our Figma designs we were able to have just one template design for each <br>
                screen, and use a mixture of the scale tool and frame resizing to get a preview <br>
                of how things would look on different devices.
            </p><!--.text,  p:nth-child(8) -->
            <div class="img">
                <img src="https://miro.medium.com/max/750/1*ExxKlGR1Pl3dEzd9xocIJA.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>There were other responsive design challenges to solve. The app had <br>
                hundreds of videos and animations, we didn’t want to have to double handle <br>
                multiple versions of the content files for different screen dimensions.
            </p><!--.text,  p:nth-child(9) -->
            <p>We created all our video / animation content to work in 4:3 but with safe areas<br>
                that could be cropped for 16:9 screens.
            </p><!--.text, p:last-child, p:last-of-tyre-->
            <div class="img">
                <img src="https://miro.medium.com/max/828/1*VsTC2wy4CJEPIIQUCLEsNg.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
        </div>
    </section>
    <section>
        <div class="text"> <!--div > p, div p-->
            <h2>Text Sizes & Internationalization</h2>
            <p>With a ‘magic number’, sometimes there will need to be exceptions — with<br>
                text in particular at smaller sizes a few pixels makes a lot of difference. But <br>
                where 8’s didn’t fit, we tried to fall back to 4’s — so some text sizes were 12 & <br>
                20px.
            </p><!--.text, p:first-child, p:first-of-tyre-->
            <p>As well as needing variations for smaller copy, we were translating the app for<br>
                6 languages. Ideal text sizes were set in the templates for headings etc, but if a<br>
                (German!) word didn’t fit within the available space, we created code to scale<br>
                it down to the next heading size that would fit.
            </p><!--.text,  p:nth-child(2) -->
            <div class="img">
                <img src="https://miro.medium.com/max/828/1*-8FrkflE7egP4wnkCtIilg.png" alt="">
                <!--.img, main div .img, body main div .img-->
            </div>
            <p>So we ended up with a larger number of heading sizes than we used in the <br>
                primary designs, but we kept a smooth transition of sizes when dropping from <br>
                H1 to H6.
            </p><!--.text, p:last-child, p:last-of-tyre-->
        </div>
    </section>
    <section>
        <div class="text"> <!--div > p, div p-->
            <h2>Summary</h2>
            <p>Most of our layouts are reasonably simple — centered elements, or 2–3 <br>
                columns of content. We were lucky not to need responsive patterns besides <br>
                the scaling system and basic layout constraints.
            </p><!--.text, p:first-child, p:first-of-tyre -->
            <p>The ‘magic number’ helps the design feel tight, it saves time when deciding<br>
                how to position, size and space things, and of course it is much easier to code <br>
                up a design that follows well defined consistent rules.
            </p><!--.text,  p:nth-child(2) -->
            <p>Next step was to figure out the
                <a href="https://medium.com/@littlebits.product/creating-themed-versions-of-a-master-design-in-figma-3d6679ffdeb7">
                    correct workflow for our themes <!--a, section div p a, div p a, a:hover-->
                </a>.
            </p><!--.text,  p:nth-child(3) -->
            <p><i>This post is part of a series
                <a href="https://medium.com/@littlebits.product/building-a-design-system-with-figma-at-littlebits-17edff8f4236">
                    Building a Design System with Figma at littleBits <!--a, section div p a, div p a, a:hover-->
                </a>. Read<br>
                the next post
                <a href="https://medium.com/@littlebits.product/creating-themed-versions-of-a-master-design-in-figma-3d6679ffdeb7">
                    Creating Themed Versions of a Master Design in Figma <!--a, section div p a, div p a, a:hover-->
                </a>.
            </i></p><!--.text, p:last-child, p:last-of-tyre-->
        </div>
    </section>
</div>
</body>
</html>